/////////////////////////////////////////////////////////////////////////////
//		CArchive.cpp
#include	<windows.h>
#include	<shlobj.h>
#include	"util.h"
#include	"ShArc.h"
#include	"resource.h"


/////////////////////////////////////////////////////////
//	錾

//֐̌^
typedef BOOL ( WINAPI *LPARCHIVE )( const HWND, LPCSTR, LPSTR, const DWORD );
typedef	BOOL ( WINAPI *LPCHECK )( LPCSTR, const int );

//萔錾
typedef struct {
	LPCTSTR	szFile;		LPCSTR	szCmd;		LPCSTR	szChk;		int	nChkMode;
} TDLLFUNC;

TDLLFUNC DllFunc[] = {
	{	_T("CAB32.DLL"  ),	"Cab"     ,	"CabCheckArchive"     ,	0	},
	{	_T("7-ZIP32.DLL"),	"SevenZip",	"SevenZipCheckArchive",	0	},
	{	_T("UNZIP32.DLL"),	"UnZip"   ,	"UnZipCheckArchive"   ,	0	},
	{	_T("UNLHA32.DLL"),	"Unlha"   ,	"UnlhaCheckArchive"   ,	0	},
	{	_T("UNRAR32.DLL"),	"Unrar"   ,	"UnrarCheckArchive"   ,	0	},
	{	_T("TAR32.DLL"  ),	"Tar"     ,	"TarCheckArchive"     ,	0	},
};


/////////////////////////////////////////////////////////
//	DLL̊֐

//RXgN^
CArchive::CArchive()
{
	//ɊǗDLL̃[h
	for( ID_DLL idDll=0; idDll<ID_DLL_MAX; ++idDll )
		m_hDLL[idDll] = LoadLibrary( DllFunc[idDll].szFile );
}

//fXgN^
CArchive::~CArchive()
{
	//ɊǗDLL̊J
	for( ID_DLL idDll=0; idDll<ID_DLL_MAX; ++idDll )
		FreeLibrary( m_hDLL[idDll] );
}

//R}h̎s
INT CArchive::Command( ID_DLL idDll, LPCTSTR lpCmdLine )
{
	LPARCHIVE	fnCmd;
	HWND		hWnd;
	INT			nResult;
	CHAR		szCmdLine[512];

	if( m_hDLL[idDll] == NULL )	return	-1;

#if UNICODE
	WideCharToMultiByte( CP_ACP, 0, lpCmdLine, -1, szCmdLine, 512, NULL, NULL );
#else
	lstrcpy( szCmdLine, lpCmdLine );
#endif
	hWnd = GetForegroundWindow();
	EnableWindow( hWnd, FALSE );
	fnCmd = (LPARCHIVE)GetProcAddress( m_hDLL[idDll], DllFunc[idDll].szCmd );
	nResult = fnCmd( hWnd, szCmdLine, NULL, 0 );
	EnableWindow( hWnd, TRUE );
	if( hWnd != GetForegroundWindow() )
		SetForegroundWindow( hWnd );

	return	nResult;
}

//t@C̃`FbN
BOOL CArchive::CheckArchive( ID_DLL idDll, LPCTSTR lpFile )
{
	LPCHECK		fnCheck;
	CHAR		szFile[MAX_PATH];

	if( m_hDLL[idDll] == NULL )	return	FALSE;

#if UNICODE
	WideCharToMultiByte( CP_ACP, 0, lpFile, -1, szFile, MAX_PATH, NULL, NULL );
#else
	lstrcpy( szCmdLine, lpFile );
#endif
	fnCheck = (LPCHECK)GetProcAddress( m_hDLL[idDll], DllFunc[idDll].szChk );
	return	fnCheck( szFile, DllFunc[idDll].nChkMode );
}


/////////////////////////////////////////////////////////
//	R}h̊֐

//gq̃`FbN
ID_ARC CArchive::CheckFileType( LPCTSTR szFile )
{
	LPCTSTR		lpExt;

	//gq̎擾
	lpExt = lstrrchr( szFile, '\\' );
	if( !lpExt )	lpExt = szFile;
	lpExt = lstrrchr( lpExt, '.' );
	if( !lpExt )	return	ID_ARC_NOT;
	++lpExt;

	//ɂ̔f
	if( lstrstri( _T("cab"), lpExt ) )
		if( CheckArchive( ID_DLL_CAB  , szFile ) )	return	ID_ARC_CAB;
	if( lstrstri( _T("7z"), lpExt ) )
		if( CheckArchive( ID_DLL_7ZIP , szFile ) )	return	ID_ARC_7Z;
	if( lstrstri( _T("zip"), lpExt ) ) {
		if( CheckArchive( ID_DLL_7ZIP , szFile ) )	return	ID_ARC_ZIP;
		if( CheckArchive( ID_DLL_UNZIP, szFile ) )	return	ID_ARC_ZIP;
	}
	if( lstrstri( _T("lzh"), lpExt ) )
		if( CheckArchive( ID_DLL_UNLHA, szFile ) )	return	ID_ARC_LHA;
	if( lstrstri( _T("rar"), lpExt ) )
		if( CheckArchive( ID_DLL_UNRAR, szFile ) )	return	ID_ARC_RAR;
//	if( lstrstri( _T("tar.z.gz.bz2.taz.tgz.tbz.cpio.rpm.deb.a.lib"), lpExt ) )
	if( lstrstri( _T("tar.z.gz.bz2.taz.tgz.tbz"), lpExt ) )
		if( CheckArchive( ID_DLL_TAR  , szFile ) )	return	ID_ARC_TAR;

	//ȉ𓀏ɂ̔f
	if( lstrstri( _T("exe"), lpExt ) )	{
		if( CheckArchive( ID_DLL_CAB  , szFile ) )	return	ID_ARC_CAB | ID_ARC_SFX;
		if( CheckArchive( ID_DLL_7ZIP , szFile ) )	return	ID_ARC_7Z  | ID_ARC_SFX;
		if( CheckArchive( ID_DLL_UNZIP, szFile ) )	return	ID_ARC_ZIP | ID_ARC_SFX;
		if( CheckArchive( ID_DLL_UNLHA, szFile ) )	return	ID_ARC_LHA | ID_ARC_SFX;
		if( CheckArchive( ID_DLL_UNRAR, szFile ) )	return	ID_ARC_RAR | ID_ARC_SFX;
	}

	return	ID_ARC_NOT;
}

//ɂ̓WJ
BOOL CArchive::ExtractArchive( ID_ARC idArc, LPCTSTR szArchive, LPCTSTR szPath )
{
	ID_DLL		idDll;
	LPCTSTR		lpCmd;
	TCHAR		szCmdLine[512];

	switch( idArc & ~ID_ARC_SFX )
	{
	case ID_ARC_CAB:	idDll = ID_DLL_CAB;		lpCmd = _T("-x"   );	break;
	case ID_ARC_ZIP:	if( m_hDLL[ID_DLL_7ZIP] == NULL )
					{	idDll = ID_DLL_UNZIP;	lpCmd = _T("-x"   );	break;	}
	case ID_ARC_7Z:		idDll = ID_DLL_7ZIP;	lpCmd = _T("x"    );	break;
	case ID_ARC_LHA:	idDll = ID_DLL_UNLHA;	lpCmd = _T("x -a1");	break;
	case ID_ARC_RAR:	idDll = ID_DLL_UNRAR;	lpCmd = _T("-x"   );	break;
	case ID_ARC_TAR:	idDll = ID_DLL_TAR;		lpCmd = _T("xvf"  );	break;
	default:			return	FALSE;
	}

	wsprintf( szCmdLine, _T("%s \x22%s\x22 \x22%s\x22"), lpCmd, szArchive, szPath );
	return	!Command( idDll, szCmdLine );
}

//ɂ̍쐬
BOOL CArchive::CompressArchive( ID_ARC idArc, LPCTSTR szArchive, LPCTSTR szPath, LPCTSTR szResponse )
{
	ID_DLL		idDll;
	LPCTSTR		lpCmd;
	TCHAR		szCmdLine[512];

	switch( idArc )
	{
	case ID_ARC_CAB:	idDll = ID_DLL_CAB;		lpCmd = _T("-a -r"     );	break;
	case ID_ARC_ZIP:	idDll = ID_DLL_7ZIP;	lpCmd = _T("a -tzip -r");	break;
	case ID_ARC_7Z:		idDll = ID_DLL_7ZIP;	lpCmd = _T("a -t7z -r" );	break;
	case ID_ARC_LHA:	idDll = ID_DLL_UNLHA;	lpCmd = _T("u -tx1r2a1");	break;
	case ID_ARC_TAR:	idDll = ID_DLL_TAR;		lpCmd = _T("cvfB"      );	break;
	default:			return	FALSE;
	}

	wsprintf( szCmdLine, _T("%s \x22%s\x22 \x22%s\x22 \x22@%s\x22"),
							lpCmd, szArchive, szPath, szResponse );
	return	!Command( idDll, szCmdLine );
}

//ȉ𓀏ɂ̍쐬
BOOL CArchive::CompressSFXArchive( ID_ARC idArc, LPCTSTR szArchive, LPCTSTR szPath, LPCTSTR szResponse )
{
	ID_DLL		idDll;
	LPCTSTR		lpCmd;
	LPCTSTR		lpExt;
	TCHAR		szWork[MAX_PATH];
	TCHAR		szDest[MAX_PATH];
	TCHAR		szCmdLine[512];
	BOOL		bRet;

	switch( idArc )
	{
	case ID_ARC_CAB:	idDll = ID_DLL_CAB;		lpCmd = _T("-f"    );	lpExt = _T(".cab");	break;
	case ID_ARC_LHA:	idDll = ID_DLL_UNLHA;	lpCmd = _T("s -gw3");	lpExt = _T(".lzh");	break;
	default:			return	FALSE;
	}

	//ɂ̍쐬
	GetTempPath( MAX_PATH, szWork );
	lstrcat( szWork, lstrrchr(szArchive, '\\') );
	*lstrrchr(szWork, '.') = 0;
	lstrcat( szWork, lpExt );

	if( !CompressArchive( idArc, szWork, szPath, szResponse ) )
		return	FALSE;

	//ȉ𓀏ɂ̍쐬
	lstrcpy( szDest, szArchive );
	*(lstrrchr(szDest, '\\')+1) = 0;
	wsprintf( szCmdLine, _T("%s \x22%s\x22 \x22%s\x22"), lpCmd, szWork, szDest );
	bRet = !Command( idDll, szCmdLine );

	DeleteFile( szWork );
	return	bRet;
}


/////////////////////////////////////////////////////////
//	WJ̊֐

//t@CWJł邩
BOOL CArchive::CheckExtractFiles( CList* pList )
{
	ULONG		nLoop;

	for( nLoop=0; nLoop<pList->GetCount(); ++nLoop )
	{
		if( CheckFileType( pList->GetItem(nLoop) ) == ID_ARC_NOT )
			return	FALSE;
	}
	return	TRUE;
}

//t@C̓WJ
BOOL CArchive::ExtractFiles( LPCTSTR szPath, CList* pList )
{
	BOOL		bKey;
	ULONG		nLoop;
	LPCTSTR		lpFile;
	ID_ARC		idArc;
	TCHAR		szFile[MAX_PATH];

	//L[̃`FbN
	bKey = GetKeyState(VK_SHIFT) & 0x8000;

	//t@CŃ[v
	for( nLoop=0; nLoop<pList->GetCount(); ++nLoop )
	{
		//t@C̃`FbN
		lpFile = pList->GetItem( nLoop );
		idArc  = CheckFileType( lpFile );
		if( idArc == ID_ARC_NOT )
			continue;

		//tH_̍쐬
		lstrcpy( szFile, szPath );
		if( !bKey )
		{
			lstrcat( szFile, lstrrchr(lpFile,'\\')+1 );
			lstrcpy( lstrrchr(szFile,'.'), _T("\\") );
			CreateDirectory( szFile, NULL );
		}

		//t@C̓WJ
		ExtractArchive( idArc, lpFile, szFile );
	}
	return	TRUE;
}


/////////////////////////////////////////////////////////
//	k̊֐

//t@Ckł邩
BOOL CArchive::CheckCompressFiles( VOID )
{
	return	( m_hDLL[ID_DLL_CAB] || m_hDLL[ID_DLL_7ZIP] || m_hDLL[ID_DLL_UNLHA] || m_hDLL[ID_DLL_TAR] );
}

//t@C̈k
BOOL CArchive::CompressFiles( ID_ARC idArc, LPCTSTR szArchive, CList* pList )
{
	TCHAR		szResponse[MAX_PATH];
	HANDLE		hResponse;
	DWORD		dwTemp;
	ULONG		nLoop;
	LPTSTR		lpItem, lpTemp;
	TCHAR		szBuff[MAX_PATH];
#if UNICODE
	CHAR		szAnsi[MAX_PATH];
#endif

	//X|Xt@C̍쐬
	GetTempPath( MAX_PATH, szResponse );
	GetTempFileName( szResponse, _T("res"), 0, szResponse );

	hResponse = CreateFile( szResponse, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_TEMPORARY, NULL );
	if( hResponse == NULL )
		return	FALSE;

	for( nLoop=0; nLoop<pList->GetCount(); ++nLoop )
	{
		lpItem = (LPTSTR)pList->GetItem(nLoop);
		lpTemp = lstrrchr( lpItem, '\\' );
		if( lpTemp )	lpTemp++;
		else			lpTemp = lpItem;

		if( GetFileAttributes( lpItem ) & FILE_ATTRIBUTE_DIRECTORY )
			wsprintf( szBuff, _T("\x22%s\\*\x22\r\n"), lpTemp );
		else
			wsprintf( szBuff, _T("\x22%s\x22\r\n"   ), lpTemp );

#if UNICODE
		WideCharToMultiByte( CP_ACP, 0, szBuff, -1, szAnsi, MAX_PATH, NULL, NULL );
		WriteFile( hResponse, szAnsi, lstrlen(szBuff), &dwTemp, NULL );
#else
		WriteFile( hResponse, szBuff, lstrlen(szBuff), &dwTemp, NULL );
#endif
	}

	CloseHandle( hResponse );

	//t@C̈k
	lstrcpy( szBuff, pList->GetItem(0) );
	lpTemp = lstrrchr(szBuff, '\\');
	if( lpTemp )	*(++lpTemp) = 0;

	if( idArc & ID_ARC_SFX )
		CompressSFXArchive( idArc & ~ID_ARC_SFX, szArchive, szBuff, szResponse );
	else
		CompressArchive( idArc, szArchive, szBuff, szResponse );

	//X|Xt@C̍폜
	DeleteFile( szResponse );

	return	TRUE;
}

//k̑I
inline VOID CompressDialogBoxAddFilter( LPTSTR lpFilter, UINT wID, LPCTSTR lpMask )
{
	LoadString( g_hInst, wID, lstrend(lpFilter), 128 );
	wsprintf( lstrend(lpFilter), _T(" (%s)|%s|"), lpMask, lpMask );
}
INT CArchive::CompressDialogBox( LPTSTR szFile )
{
	TCHAR		szFilter[512];
	LPTCH		lpCh;
	DWORD		dwIndex;

	//tB^̍쐬
	szFilter[0]=0;
	if( m_hDLL[ID_DLL_CAB  ] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_CAB   , _T("*.cab"                                 ) );
	if( m_hDLL[ID_DLL_7ZIP ] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_ZIP   , _T("*.zip"                                 ) );
	if( m_hDLL[ID_DLL_7ZIP ] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_7Z    , _T("*.7z"                                  ) );
	if( m_hDLL[ID_DLL_UNLHA] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_LHA   , _T("*.lzh"                                 ) );
	if( m_hDLL[ID_DLL_TAR  ] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_TAR   , _T("*.tar;*.z;*.gz;*.bz2;*.taz;*.tgz;*.tbz") );
	if( m_hDLL[ID_DLL_CAB  ] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_CABSFX, _T("*.exe"                                 ) );
	if( m_hDLL[ID_DLL_UNLHA] )	CompressDialogBoxAddFilter( szFilter, IDS_NAME_LHASFX, _T("*.exe"                                 ) );
	for( lpCh=szFilter; *lpCh; ++lpCh )
		if( *lpCh=='|' )	*lpCh=0;

	//t@C̑I
	dwIndex = SaveDialogBox( szFile, szFilter );

	//^Cv̌
	if(                         !dwIndex-- )	return	ID_ARC_NOT;
	if( m_hDLL[ID_DLL_CAB  ] && !dwIndex-- )	return	ID_ARC_CAB;
	if( m_hDLL[ID_DLL_7ZIP ] && !dwIndex-- )	return	ID_ARC_ZIP;
	if( m_hDLL[ID_DLL_7ZIP ] && !dwIndex-- )	return	ID_ARC_7Z;
	if( m_hDLL[ID_DLL_UNLHA] && !dwIndex-- )	return	ID_ARC_LHA;
	if( m_hDLL[ID_DLL_TAR  ] && !dwIndex-- )	return	ID_ARC_TAR;
	if( m_hDLL[ID_DLL_CAB  ] && !dwIndex-- )	return	ID_ARC_CAB | ID_ARC_SFX;
	if( m_hDLL[ID_DLL_UNLHA] && !dwIndex-- )	return	ID_ARC_LHA | ID_ARC_SFX;
												return	ID_ARC_NOT;
}
