/////////////////////////////////////////////////////////////////////////////
//		CUnknown.cpp
#include	<windows.h>
#include	<shlobj.h>
#include	"util.h"
#include	"ShArc.h"
#include	"resource.h"


/////////////////////////////////////////////////////////
//	錾

//萔
enum { ID_COMPRESS=1, ID_EXTRACT=2 };

//ϐ
UINT		g_cRefThisDll = 0;			//DLLQƂ


/////////////////////////////////////////////////////////
//	NXIuWFNg̑

//NXIuWFNg̊J
BOOL IsDllUnlocked()
{
	return	( g_cRefThisDll == 0 );
}


/////////////////////////////////////////////////////////
//	NXIuWFNg̊Ǘ

//RXgN^EfXgN^
CClassFactory::CClassFactory()
{
	++g_cRefThisDll;
	m_nRef = 1;
}
CClassFactory::~CClassFactory()
{
	--g_cRefThisDll;
}

//IUnknown

//IuWFNǧJ
STDMETHODIMP CClassFactory::QueryInterface( REFIID riid, LPVOID* ppvObj )
{
	HRESULT	hr;

	if( riid == IID_IUnknown || riid == IID_IClassFactory )
	{
		*ppvObj = this;
		hr      = NOERROR;
		++m_nRef;
	}
	else
	{
		*ppvObj = NULL;
		hr      = E_NOINTERFACE;
	}

	return	hr;
}

//IuWFNg̎QƁEJ
STDMETHODIMP_(ULONG) CClassFactory::AddRef()
{
	return	++m_nRef;
}
STDMETHODIMP_(ULONG) CClassFactory::Release()
{
	if( --m_nRef == 0 )
		delete this;
	return	m_nRef;
}

//IClassFactory

//w肵CLSID̃IuWFNg쐬
STDMETHODIMP CClassFactory::CreateInstance( LPUNKNOWN pUnkOuter, REFIID riid, LPVOID* ppvObj )
{
	HRESULT				hr;
	CShellExtension*	pShellExtension;

	*ppvObj = NULL;
	if( pUnkOuter != NULL )
		return	CLASS_E_NOAGGREGATION;

	pShellExtension = new CShellExtension;
	if( pShellExtension == NULL )
		return	E_OUTOFMEMORY;

	hr = pShellExtension->QueryInterface( riid, ppvObj );
		 pShellExtension->Release();

	return	hr;
}

//NXt@NgbN
STDMETHODIMP CClassFactory::LockServer( BOOL fLock )
{
	return	E_NOTIMPL;
}


/////////////////////////////////////////////////////////
//	VFg

//RXgN^EfXgN^
CShellExtension::CShellExtension()
{
	++g_cRefThisDll;
	m_nRef		= 1;
	m_pList		= NULL;
	m_pArchive	= NULL;
	m_szPath[0]	= 0;
}
CShellExtension::~CShellExtension()
{
	--g_cRefThisDll;
}

//IUnknown

//IuWFNǧJ
STDMETHODIMP CShellExtension::QueryInterface( REFIID riid, LPVOID* ppvObj )
{
	HRESULT		hr;

	if( riid == IID_IUnknown )
	{
		*ppvObj = (LPUNKNOWN)(LPCONTEXTMENU)this;
		hr = NOERROR;
		++m_nRef;
	}
	else if( riid == IID_IContextMenu )
	{
		*ppvObj = (LPCONTEXTMENU)this;
		hr = NOERROR;
		++m_nRef;
	}
	else if( riid == IID_IShellExtInit )
	{
		*ppvObj = (LPSHELLEXTINIT)this;
		hr = NOERROR;
		++m_nRef;
	}
	else
	{
		*ppvObj = NULL;
		hr = E_NOINTERFACE;
	}

	return	hr;
}

//IuWFNg̎QƁEJ
STDMETHODIMP_(ULONG) CShellExtension::AddRef()
{
	return	++m_nRef;
}
STDMETHODIMP_(ULONG) CShellExtension::Release()
{
	if( --m_nRef == 0 )
	{
		delete m_pArchive;	m_pArchive = NULL;
		delete m_pList;		m_pList    = NULL;
		delete this;
	}
	return	m_nRef;
}

//IShellExtInit

//
STDMETHODIMP CShellExtension::Initialize( LPCITEMIDLIST pidlFolder, LPDATAOBJECT lpdobj, HKEY hKeyProgID )
{
	HRESULT		hr;
	STGMEDIUM	medium;
	FORMATETC	fe = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
	ULONG		cMax, cLoop;
	TCHAR		szBuff[MAX_PATH];

	if( lpdobj == NULL )
		return	E_FAIL;

	hr = lpdobj->GetData( &fe, &medium );
	if( FAILED(hr) )
		return	E_FAIL;

	//Ώۃt@C̎擾
	cMax = DragQueryFile( (HDROP)medium.hGlobal, (UINT)-1, NULL, 0 );
	if( cMax > 0 )
	{
		m_pList = new CList( cMax );
		for( cLoop = 0; cLoop < cMax; ++cLoop )
		{
			DragQueryFile( (HDROP)medium.hGlobal, cLoop, szBuff, MAX_PATH );
			m_pList->AddItem( szBuff );
		}
		hr = S_OK;
	}
	else
		hr = E_FAIL;

	//ΏۃpX̎擾
	if( pidlFolder )
	{
		SHGetPathFromIDList( pidlFolder, m_szPath );
		if( *(lstrend(m_szPath)-1) != '\\' )	lstrcat( m_szPath, _T("\\") );
	}
	else
	{
		lstrcpy( m_szPath, m_pList->GetItem(0) );
		*(lstrrchr(m_szPath,'\\') + 1) = 0;
	}

	ReleaseStgMedium( &medium );

	m_pArchive = new CArchive;

	return hr;
}

//IContextMenu

//j[ɍڂǉ
STDMETHODIMP CShellExtension::QueryContextMenu( HMENU hMenu,UINT indexMenu, UINT idCmdFirst, UINT idCmdLast,UINT uFlags )
{
	USHORT	cItem=1;
	TCHAR	szBuff[128];

	//WJ
	if( m_pArchive->CheckExtractFiles( m_pList ) )
	{
		LoadString( g_hInst, (uFlags & ~CMF_RESERVED ? IDS_CONT_EXTRACT : IDS_DROP_EXTRACT), szBuff, 128 );
		InsertMenu( hMenu, indexMenu++, MF_STRING | MF_BYPOSITION, idCmdFirst + ID_EXTRACT, szBuff );
		++cItem;
	}

	//k
	if( m_pArchive->CheckCompressFiles() )
	{
		LoadString( g_hInst, (uFlags & ~CMF_RESERVED ? IDS_CONT_COMPRESS : IDS_DROP_COMPRESS), szBuff, 128 );
		InsertMenu( hMenu, indexMenu++, MF_STRING | MF_BYPOSITION, idCmdFirst + ID_COMPRESS, szBuff );
		++cItem;
	}

	return ResultFromScode(MAKE_SCODE(SEVERITY_SUCCESS, FACILITY_NULL, cItem));
}

//ǉڂI
STDMETHODIMP CShellExtension::InvokeCommand( LPCMINVOKECOMMANDINFO lpici )
{
	if( HIWORD(lpici->lpVerb) )
		return	E_FAIL;

	switch( LOWORD(lpici->lpVerb) )
	{
	case	ID_EXTRACT:					//WJ
		m_pArchive->ExtractFiles( m_szPath, m_pList );
		break;
	case	ID_COMPRESS:				//k
		{
			TCHAR		szFile[MAX_PATH];
			LPCTSTR		lpFull, lpFile;
			ID_ARC		idArc;

			lpFull = m_pList->GetItem(0);
			lpFile = lstrrchr( lpFull, '\\' );

			lstrcpy( szFile, m_szPath );
			lstrcat( szFile, lpFile ? lpFile+1 : lpFull );

			idArc = m_pArchive->CompressDialogBox( szFile );
			if( idArc != ID_ARC_NOT )
				m_pArchive->CompressFiles( idArc, szFile, m_pList );
		}
		break;
	default:							//̑
		return	E_INVALIDARG;
	}

	return	NOERROR;
}

//ڂ̃wv
STDMETHODIMP CShellExtension::GetCommandString( UINT idCmd, UINT uType, UINT* pwReserved, LPSTR pszName, UINT cchMax )
{
	if( uType == GCS_HELPTEXT )
	{
		switch( idCmd )
		{
		case	ID_EXTRACT:					//WJ
			LoadString( g_hInst, IDS_HELP_EXTRACT , (LPTSTR)pszName, cchMax );
			break;
		case	ID_COMPRESS:				//k
			LoadString( g_hInst, IDS_HELP_COMPRESS, (LPTSTR)pszName, cchMax );
			break;
		default:							//̑
			return	ResultFromScode(E_INVALIDARG);
		}
	}
	return	NOERROR;
}
